using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;



namespace SDGPong
{
	public class Form1 : System.Windows.Forms.Form
	{
		private Sdgt.SdgManager sdgManager1;
		private System.ComponentModel.IContainer components;

		int ball_x, ball_y;
		int user1, user2, user3, user4;
		int ballSize = 18;
		int ballSizeOffset = 9;
		int x_vel=-5, y_vel=-5;
		int score1 = 0;
		int score2 = 0;
		int numberOfPlayers;
		int paddelLength = 50;

		int maxX, maxY;
		
		Pen ballPen, paddlePen;
		Pen user1pen, user2pen, user3pen, user4pen;

		Graphics g;
		Timer gameClock;
		Random randNum;

		private System.Windows.Forms.Label label1;
		private SDGPong.SDGButton sdgButton1;
		private SDGPong.SDGButton sdgButton2;
		private SDGPong.SDGButton sdgButton3;	
		bool clrForm = false;

		private System.Drawing.SolidBrush myBrush = new System.Drawing.SolidBrush(Color.Blue);
		private GroupLab.Phidgets.InterfaceKit interfaceKit1;
		private int delay = 1000;
		private System.Windows.Forms.Label label2;
		private SDGPong.SDGButton sdgButton4;

		private bool phidgetsOnly = false;
		private GroupLab.Phidgets.TextLCD textLCD1;
		private System.Windows.Forms.Timer timer1;
		private bool firstTime = true;


		public Form1()
		{
			SetStyle(ControlStyles.UserPaint, true);
			SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			SetStyle(ControlStyles.DoubleBuffer, true);
			SetStyle(ControlStyles.UserPaint, true);
			SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			SetStyle(ControlStyles.DoubleBuffer, true);

			this.initScreen();
		
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}




		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.sdgManager1 = new Sdgt.SdgManager(this.components);
			this.label1 = new System.Windows.Forms.Label();
			this.sdgButton1 = new SDGPong.SDGButton();
			this.sdgButton2 = new SDGPong.SDGButton();
			this.sdgButton3 = new SDGPong.SDGButton();
			this.interfaceKit1 = new GroupLab.Phidgets.InterfaceKit();
			this.label2 = new System.Windows.Forms.Label();
			this.sdgButton4 = new SDGPong.SDGButton();
			this.textLCD1 = new GroupLab.Phidgets.TextLCD();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// sdgManager1
			// 
			this.sdgManager1.EmulateSystemMouseMode = Sdgt.EmulateSystemMouseModes.Park;
			this.sdgManager1.Keyboards = null;
			this.sdgManager1.Mice = null;
			this.sdgManager1.MouseToFollow = 0;
			this.sdgManager1.ParkSystemMouseLocation = new System.Drawing.Point(350, 350);
			this.sdgManager1.RelativeTo = this;
			this.sdgManager1.MouseMove += new Sdgt.SdgMouseEventHandler(this.sdgManager1_MouseMove);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 18F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(0, 48);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(632, 40);
			this.label1.TabIndex = 1;
			this.label1.Text = "SDG and Phidget Pong";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// sdgButton1
			// 
			this.sdgButton1.BackColor = System.Drawing.Color.YellowGreen;
			this.sdgButton1.CausesValidation = false;
			this.sdgButton1.Location = new System.Drawing.Point(168, 192);
			this.sdgButton1.Name = "sdgButton1";
			this.sdgButton1.Size = new System.Drawing.Size(136, 96);
			this.sdgButton1.TabIndex = 2;
			// 
			// sdgButton2
			// 
			this.sdgButton2.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.sdgButton2.CausesValidation = false;
			this.sdgButton2.Location = new System.Drawing.Point(336, 192);
			this.sdgButton2.Name = "sdgButton2";
			this.sdgButton2.Size = new System.Drawing.Size(136, 304);
			this.sdgButton2.TabIndex = 3;
			// 
			// sdgButton3
			// 
			this.sdgButton3.BackColor = System.Drawing.Color.DarkSeaGreen;
			this.sdgButton3.CausesValidation = false;
			this.sdgButton3.Location = new System.Drawing.Point(168, 296);
			this.sdgButton3.Name = "sdgButton3";
			this.sdgButton3.Size = new System.Drawing.Size(136, 96);
			this.sdgButton3.TabIndex = 4;
			// 
			// interfaceKit1
			// 
			this.interfaceKit1.AutoAttach = true;
			this.interfaceKit1.PhidgetDevice = null;
			this.interfaceKit1.SensorChange += new GroupLab.Phidgets.IndexSensorChangeEventHandler(this.interfaceKit1_SensorChange);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(64, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(528, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "SDG example, by Nicolai Marquardt, 2005 (Game algorithm based on tutorial by Davi" +
				"d Sosby 2002) ";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// sdgButton4
			// 
			this.sdgButton4.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(128)));
			this.sdgButton4.CausesValidation = false;
			this.sdgButton4.Location = new System.Drawing.Point(168, 400);
			this.sdgButton4.Name = "sdgButton4";
			this.sdgButton4.Size = new System.Drawing.Size(136, 96);
			this.sdgButton4.TabIndex = 6;
			// 
			// textLCD1
			// 
			this.textLCD1.AutoAttach = true;
			this.textLCD1.Display = null;
			this.textLCD1.PhidgetDevice = null;
			// 
			// timer1
			// 
			this.timer1.Interval = 500;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 555);
			this.Controls.Add(this.sdgButton4);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.sdgButton3);
			this.Controls.Add(this.sdgButton2);
			this.Controls.Add(this.sdgButton1);
			this.Controls.Add(this.label1);
			this.Name = "Form1";
			this.Text = "SDG and Phidget Pong";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}



		private void firstTimeExec()
		{
			this.Paint += new PaintEventHandler(paint1);
			this.KeyUp += new KeyEventHandler(keyHandler);
			ballPen = new Pen(Color.Blue, 1);
			paddlePen = new Pen(Color.Red, 5);

			if(this.numberOfPlayers == 2)
			{
				user1pen = new Pen(Color.YellowGreen, 5);
				user2pen = new Pen(Color.Tomato, 5);
				user3pen = new Pen(Color.YellowGreen, 5);
				user4pen = new Pen(Color.Tomato, 5);
			}
			else
			{
				user1pen = new Pen(Color.Aqua, 5);
				user2pen = new Pen(Color.GreenYellow, 5);
				user3pen = new Pen(Color.YellowGreen, 5);
				user4pen = new Pen(Color.Tomato, 5);
			}

			gameClock = new Timer();
			gameClock.Tick += new EventHandler(gameLoop);
			firstTime = false;
			user1 = 100;
			user2 = 100;
			user3 = 100;
			user4 = 100;
			maxX = this.Width - 20;
			maxY = this.Height - 60;
		}


		private void myplay()  
		{

			for(int i = 0; i < this.sdgManager1.Mice.Count; ++i)
			{
				this.sdgManager1.Mice[i].Visible = false;
			}

			Controls.Remove(this.label1);
			Controls.Remove(this.label2);
			Controls.Remove(this.sdgButton1);
			Controls.Remove(this.sdgButton2);
			Controls.Remove(this.sdgButton3);
			Controls.Remove(this.sdgButton4);

			//label3.Visible = true;

			if(this.numberOfPlayers == 2)
			{
				user1pen = new Pen(Color.YellowGreen, 5);
				user2pen = new Pen(Color.Tomato, 5);
				user3pen = new Pen(Color.YellowGreen, 5);
				user4pen = new Pen(Color.Tomato, 5);
			}
			else
			{
				user1pen = new Pen(Color.Aqua, 5);
				user2pen = new Pen(Color.GreenYellow, 5);
				user3pen = new Pen(Color.YellowGreen, 5);
				user4pen = new Pen(Color.Tomato, 5);
			}

			if(firstTime) this.firstTimeExec();

			randNum = new Random();
			ball_x = randNum.Next(295)+10;
			ball_y = randNum.Next(295)+10;
		
			clrForm = false;
			gameClock.Interval = 1;
			
			gameClock.Start();
		}




		public void buttonControl(String message)
		{
			if(message == "Quit")
			{
				Application.Exit();
			} 
			else if(message == "2 Players")
			{
				this.myplay();
				this.numberOfPlayers = 2;
			}
			else if(message == "4 Players")
			{			
				this.myplay();
				this.numberOfPlayers = 4;
			} 
			else if(message == "Phidgets only")
			{			
				this.myplay();
				this.numberOfPlayers = 2;
				this.phidgetsOnly = true;
			}
		}


		//This tests to see if the Escape key has been hit. If so, gameOver() is called
		private void keyHandler(Object sender, KeyEventArgs e)  
		{
			if ( e.KeyCode == Keys.Escape )
				gameOver();
		}
	

		private void paint1(Object sender, PaintEventArgs e)  
		{
			g = e.Graphics;
			gameDraw();
		}

	
		private void gameDraw()  
		{
			if ( !clrForm )  
			{
				g.FillEllipse(myBrush, ball_x, ball_y, ballSize, ballSize);
				g.DrawLine(user1pen, user1, maxY , user1+paddelLength, maxY);
				g.DrawLine(user2pen, maxX, user2, maxX, user2+ paddelLength);
				g.DrawLine(user3pen, user3, 10, user3+paddelLength, 10);
				g.DrawLine(user4pen, 10, user4, 10, user4+ paddelLength);
			}
		}



		private void updateScore(int number)
		{
			if(number == 1)
			{
				score1++;

			} 
			else if (number == 2) 
			{
				score2++;

			}
			
		}


		private void gameLoop(Object sender, EventArgs e)  
		{


			for (int i = 0; i < delay; ++i);

			int ball_m_x = ball_x + ballSizeOffset;
			int ball_m_y = ball_y + ballSizeOffset;


			// left
			if (  ball_x <= 10 &&  ball_x >= 4 &&  ball_m_y >= user4 - 3 &&  ball_m_y <= user4+paddelLength + 3 )  
			{
				x_vel *= -1;		
				updateScore(2);
			}

			// top
			if ( ball_y <= 10 && ball_y >= 5 && ball_m_x >= user3 - 3 && ball_m_x <= user3+paddelLength+ 3 )  
			{
				y_vel *= -1;			
				updateScore(2);
			}

			// right
			if ( ball_x + this.ballSize >= maxX && ball_x + this.ballSize <= maxX + 5 && ball_m_y >= user2 - 3 && ball_m_y <= user2+paddelLength + 3)  
			{
				x_vel = -1+(randNum.Next(2)-2);			
				updateScore(1);
			}

			// bottom
			if ( ball_y + this.ballSize >= maxY && ball_y + this.ballSize <= maxY + 5 && ball_m_x >= user1 - 3 && ball_m_x <= user1+paddelLength + 3 )  
			{
				y_vel *= -1;
				updateScore(1);
			}

			if (ball_m_y>= maxY + 20 || ball_m_x >= maxX + 20  || ball_m_x <= 0  || ball_m_y <= 0)
				gameOver();
				
			ball_x += x_vel;
			ball_y += y_vel;
		
			Invalidate();
			
		}
	

		private void gameOver()  
		{
			//gameClock.Stop();
			//gameClock.Dispose();
			
			//clrForm = true;
			//Invalidate();
			//this.initScreen();
			this.myplay();

		}


		public void initScreen()
		{

			this.InitializeComponent();
			this.sdgButton1.setParameters(this, "2 Players");
			this.sdgButton2.setParameters(this, "Quit");
			this.sdgButton3.setParameters(this, "4 Players");
			this.sdgButton4.setParameters(this, "Phidgets only");

			for(int i = 0; i < this.sdgManager1.Mice.Count; ++i)
			{
				this.sdgManager1.Mice[i].Visible = true;
			}

		}


		private void sdgManager1_MouseMove(object sender, Sdgt.SdgMouseEventArgs e)
		{
			if(!phidgetsOnly)
			{
				if(this.numberOfPlayers == 2)
				{
					if(e.ID == 0)
					{
						user1 = e.X-25;
						user3 = e.X-25;
					} 
					else if (e.ID == 1)
					{
						user2 = e.X-25;
						user4 = e.X-25;
					} 
				} 
				else 
				{
					if(e.ID == 0)
					{
						user1 = e.X-25;
					} 
					else if (e.ID == 1)
					{
						user2 = e.X-25;
					} 
					else if (e.ID == 2)
					{
						user3 = e.X-25;
					} 
					else if (e.ID == 3)
					{
						user4 = e.X-25;
					}
				}


				if(user1 < 0) user1 = 0;
				if(user2 < 0) user2 = 0;
				if(user3 < 0) user3 = 0;
				if(user4 < 0) user4 = 0;

				if(user1 > maxX) user1 = maxX;
				if(user2 > maxY) user2 = maxY;
				if(user3 > maxX) user3 = maxX;
				if(user4 > maxY) user4 = maxY;
			}

		}



		private void interfaceKit1_SensorChange(object sender, GroupLab.Phidgets.IndexSensorChangeEventArgs e)
		{
			if(e.Index == 0)
			{
				user1 = (int)((e.Value / 1000.0) * maxX);
				user3 = (int)((e.Value / 1000.0) * maxX);
			} 
			else if (e.Index == 1)
			{
				user2 = (int)((e.Value / 1000.0) * maxY);
				user4 = (int)((e.Value / 1000.0) * maxY);

			}
			else if (e.Index == 2)
			{
				//gameClock.Interval = (int)((e.Value / 1000.0) * 50.0) + 1;
				//gameClock.Start();
				delay = (int)((e.Value / 1000.0) * 10000000.0);
				//System.Console.WriteLine("value:" + delay);
			}
		}


		private void timer1_Tick(object sender, System.EventArgs e)
		{
			if(textLCD1.Attached == true)
			{
				if(!phidgetsOnly)
				{
					if(this.numberOfPlayers == 2)
					{
						textLCD1.Display = "Player1: " + score1 + "; Player2: " + score2;
						
					} 
					else if(this.numberOfPlayers == 4)
					{
						textLCD1.Display = "Team1: " + score1 + "; Team2: " + score2;
					} 
				} 
				else 
				{
					textLCD1.Display = "Player1: " + score1 + "; Player2: " + score2;
				}
			}
		}




	}
}
